---
title: RTCPeerConnection.generateCertificate() static function
slug: Web/API/RTCPeerConnection/generateCertificate
tags:
  - API
  - Media
  - Method
  - RTCPeerConnection
  - Reference
  - Security
  - Static Method
  - WebRTC
  - WebRTC API
  - generateCertificate
---
<p>{{APIRef("WebRTC")}}</p>

<p>The static  <strong><code>RTCPeerConnection.generateCertificate()</code></strong> function creates an X.509 certificate and corresponding private key, returning a promise that resolves with the new {{domxref("RTCCertificate")}} once it's generated.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <em>certPromise</em> = RTCPeerConnection.generateCertificate(<em>keygenAlgorithm</em>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>keygenAlgorithm</code></dt>
 <dd>A <a href="/en-US/docs/Web/API/Web_Crypto_API">Web Crypto API</a> {{domxref("AlgorithmIdentifier")}} string or an {{domxref("Algorithm")}} -subclassed object specifying an algorithm to use when creating the certificate's key.</dd>
</dl>

<div class="note">
<p><code>RTCPeerConnection.generateCertificate()</code> is a static method, so it is always called on the <code>RTCPeerConnection</code> interface itself, not an instance thereof.</p>
</div>

<h3 id="Return_value">Return value</h3>

<p>A promise which resolves to a new {{domxref("RTCCertificate")}} object containing a new key based on the specified options.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>NotSupportedError</code></dt>
 <dd>The normalized form of <code>keygenAlgorithm</code> specifies an algorithm or algorithm settings that the browser doesn't support, or which it does not allow for use with an {{domxref("RTCPeerConnection")}}.</dd>
</dl>

<p>Other errors may occur; for example, if the specified <code>keygenAlgorithm</code> can't be successfully converted into an {{domxref("RTCCertificateExpiration")}} dictionary, the error that occurs during that conversion will be thrown.</p>

<h2 id="Description">Description</h2>

<p>If a string is specified, it must be a <a href="/en-US/docs/Web/API/Web_Crypto_API">Web Crypto API</a>-compatible algorithm name string. Alternatively, you can provide specific details for the algorithm's configuration by providing an object based on one of the Web Crypto API's {{domxref("Algorithm")}} class's subclasses.</p>

<h3 id="Standard_configurations">Standard configurations</h3>

<p>All browsers are required to support the following two configurations. It's entirely possible that a browser's <em>default</em> settings may be different, but these are always supported.</p>

<h4 id="RSASSA-PKCS1-v1_5">RSASSA-PKCS1-v1_5</h4>

<pre class="brush: js notranslate">let stdRSACertificate = {
  name: "RSASSA-PKCS10-v1_5",
  modulusLength: 2048,
  publicExponent: new UInt8Array([1, 0, 1]),
  hash: "SHA-256"
};
</pre>

<h4 id="ECDSA">ECDSA</h4>

<pre class="brush: js notranslate">let stdECDSACertificate = {
  name: "ECDSA",
  namedCurve: "P-256"
};
</pre>

<h3 id="Certificate_expiration_time">Certificate expiration time</h3>

<p>By default the new certificate is configured with <code>expires</code> set to a {{domxref("DOMTimeStamp")}} value of 2592000000, or 30 days. The expiration time cannot exceed 31536000000, or 365 days. It's also useful to note that browsers may further restrict the expiration time of certificates if they choose.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Specifying_algorithm_details">Specifying algorithm details</h3>

<p>This example requests a new RSASSA-PKCS1-v1_5 certificate using a SHA-256 hash and a modulus length of 2048.</p>

<pre class="brush: js notranslate">RTCPeerConnection.generateCertificate({
    name: 'RSASSA-PKCS1-v1_5',
    hash: 'SHA-256',
    modulusLength: 2048,
    publicExponent: new Uint8Array([1, 0, 1])
}).then(function(cert) {
  var pc = new RTCPeerConnection({certificates: [cert]});
});</pre>

<h3 id="Specifying_an_algorithm_by_name">Specifying an algorithm by name</h3>

<p>The example below specifies a string requesting an <a href="https://en.wikipedia.org/wiki/Elliptic_Curve_Digital_Signature_Algorithm">ECDSA</a> certificate.</p>

<pre class="brush: js notranslate">RTCPeerConnection.generateCertificate("ECDSA");
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcpeerconnection-generatecertificate', 'RTCPeerConnection.generateCertificate()')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.generateCertificate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Crypto_API">Web Crypto API</a></li>
 <li><a href="/en-US/docs/Learn/Server-side/First_steps/Website_security">Web site security</a></li>
 <li><a href="/en-US/docs/Web/Security">Web security</a></li>
 <li>{{Glossary("Symmetric-key cryptography")}}</li>
 <li><code><a href="/en-US/docs/Web/API/Window/crypto">Window.crypto</a></code></li>
</ul>
